//package com.sonydna.common.extensions;
//
//import org.apache.commons.io.FilenameUtils;
//
//
//public aspect Constraints {
//	declare error
//	: call(* javax.crypto.Cipher.getInstance(..)) && !within(com.sonydna.common.extensions.ScAES)
//	: "use ScAES instead of javax.crypto.Cipher";
//	
//	declare error
//	: call(* android.graphics.Bitmap.compress(..)) && !within(com.sonydna.common.extensions.ScBitmap)
//	: "use ScBitmap.write() instead of android.graphics.Bitmap.compress()";
//	
//	declare error
//	: call(* android.graphics.BitmapFactory.decodeResource(..)) && !within(com.sonydna.common.extensions.ScBitmap)
//	: "use ScBitmap.asBitmap() instead of android.graphics.BitmapFactory.decodeResource()";
//	
//	declare error
//	: call(android.media.ExifInterface.new(..)) && !within(com.sonydna.common.extensions.ScExifInterface)
//	: "use ScExifInterface.getExif() instead of ExifInterface";
//	
//	declare error
//	: call(* android.media.ExifInterface.getAttributeInt(..)) && !within(com.sonydna.common.extensions.ScExifInterface)
//	: "use ScExifInterface instead of ExifInterface";
//	
//	declare error
//	: call(* android.media.ExifInterface.getAttribute(..)) && !within(com.sonydna.common.extensions.ScExifInterface)
//	: "use ScExifInterface instead of ExifInterface";
//	
//	declare error
//	: call(* android.media.ExifInterface.getThumbnail(..)) && !within(com.sonydna.common.extensions.ScExifInterface)
//	: "use ScExifInterface.decodeBitmap() instead of ExifInterface.getThumbnail()";
//	
//	declare error
//	: call(* android.os.Environment.getDataDirectory(..)) && !within(com.sonydna.common.extensions.ScFile)
//	: "use ScFile.getDataDirectory() instead of android.os.Environment.getDataDirectory()";
//	
//	declare error
//	: call(* android.os.Environment.getExternalStorageDirectory(..)) && !within(com.sonydna.common.extensions.ScFile)
//	: "use ScFile.getExternalStorageDirectory() instead of android.os.Environment.getExternalStorageDirectory()";
//	
//	declare error
//	: call(* android.content.Context.getCacheDir(..)) && !within(com.sonydna.common.extensions.ScFile)
//	: "use ScFile.getCacheDir() instead of android.content.Context.getCacheDir()";
//	
//	declare error
//	: call(* android.content.Context.getExternalCacheDir(..)) && !within(com.sonydna.common.extensions.ScFile)
//	: "use ScFile.getExternalCacheDir() instead of android.content.Context.getExternalCacheDir()";
//	
//	declare error
//	: call(* android.content.Context.getContentResolver(..)) && !within(com.sonydna.common.extensions.ScFile) && !within(com.sonydna.common.extensions.ScMediaStoreImages)
//	: "use ScMediaStoreImages instead of android.content.Context.getContentResolver()";
//	
//	declare error
//	: call(android.os.StatFs.new(..)) && !within(com.sonydna.common.extensions.ScFile)
//	: "use ScFile.getFreeSpace_lv8() instead of android.os.StatFs";
//	
//	declare error
//	: call(* java.io.File.getFreeSpace(..)) && !within(com.sonydna.common.extensions.ScFile)
//	: "use ScFile.getFreeSpace_lv8() instead of java.io.File.getFreeSpace()";
//
//	declare error
//	: call(* android.media.MediaScannerConnection.scanFile(..)) && !within(com.sonydna.common.extensions.ScFile)
//	: "use ScFile.beginScan() instead of android.media.MediaScannerConnection.scanFile";
//	
//	declare error
//	: call(* org.apache.commons.io.FilenameUtils.getExtension(..)) && !within(com.sonydna.common.extensions.ScFile)
//	: "use ScFile.ScExtension instead of org.apache.commons.io.FilenameUtils.getExtension()";
//
//	declare error
//	: call(* org.apache.http.util.EntityUtils.toString(..)) && !within(com.sonydna.common.extensions.ScHttpResponse)
//	: "use ScHttpResponse.getBodyString instead of org.apache.http.util.EntityUtils.toString()";
//	
//	declare error
//	: call(java.io.FileOutputStream.new(..)) && !within(com.sonydna.common.extensions.ScInputStream)
//	: "use ScInputStream.write() instead of java.io.FileOutputStream";
//
//	declare error
//	: call(java.util.Random.new(..))
//	: "use ScRandom instead of java.util.Random";
//	
//	declare error
//	: call(* android.telephony.TelephonyManager.getSimOperator(..)) && !within(com.sonydna.common.extensions.ScTelephonyManager)
//	: "use ScTelephonyManager.getSimOperator() instead of android.telephony.TelephonyManager.getSimOperator()";
//	
//	declare error
//	: call(* android.webkit.WebView.loadData(..)) && !within(com.sonydna.common.extensions.ScWebView)
//	: "use ScWebView.loadData() instead of android.webkit.WebView.loadData()";
//
//	declare error
//	: call(* java.io.File.length()) && !within(com.sonydna.common.extensions.ScByteSize)
//	: "use ScByteSize.getByteSize(File e) instead of java.io.File.length()";
//	
//	declare error
//	: call(* java.net.URLConnection.contentLength()) && !within(com.sonydna.common.extensions.ScByteSize)
//	: "use ScByteSize.getByteSize(URLConnection e) instead of java.net.URLConnection.contentLength()";
//	
//	declare error
//	: call(* android.content.Context.getSystemService(..)) && !within(com.sonydna.common.extensions.ScContext)
//	: "use ScContext instead of android.content.Context.getSystemService()";
//	
//	declare error
//	: call(* android.view.View.findViewById(..)) && !within(com.sonydna.common.extensions.ScContext)
//	: "use ScView instead of android.view.View.findViewById()";
//	
//	declare error
//	: @withincode(com.sonydna.common.annotation.Pure) &&
//	  call(!@com.sonydna.common.annotation.QualifyAsPure * *(..)) &&
//	  call(!@com.sonydna.common.annotation.Pure * *(..)) &&
//	  !call(* java.io.File.length())
//	: "SideEffected";
//}
