package com.sonydna.common.extensions

import java.util.Iterator
import java.util.BitSet
import com.sonydna.common.annotation.null_analysis.NonNullByDefault

@NonNullByDefault
final class ScBitSetIterator implements Iterator<Integer> {
	
	val BitSet bitSet
	var int    next
	
	new(BitSet bitSet) {
		this.bitSet = bitSet
		this.next   = bitSet.nextSetBit(0)
	}
	
	override hasNext() {
		0 <= next
	}
	
	override next() {
        val result = next
        next = bitSet.nextSetBit(next + 1)
        return new Integer(result)
	}
	
	override remove() {
		throw new UnsupportedOperationException
	}
}
