package com.sonydna.common.extensions

import android.test.AndroidTestCase
import android.graphics.Bitmap

import static extension com.sonydna.common.extensions.ScBitmap.*
import static extension com.sonydna.common.extensions.ScByteSize.*
import com.sonydna.common.annotation.null_analysis.NonNullByDefault

@NonNullByDefault
final class ScByteSizeTest extends AndroidTestCase {
	
	def static void test01() {
		assertTrue(1.b  < 1.kb)
		assertTrue(1.kb < 1.mb)
		
		assertTrue(1024.b  == 1.kb)
		assertTrue(1024.kb == 1.mb)
		
		assertTrue( 512.b  * 2 == 1.kb)
		assertTrue(2048.kb / 2 == 1.mb)
		
		assertTrue(256.b * 2 + 1023.kb == 1.mb - 1.kb / 2)
		
		val bitmap = new ScDimension(2, 2).asBitmap(Bitmap.Config.RGB_565)
		assertTrue(bitmap.byteSize == 8.b)
		bitmap.recycle
	}
}
