package com.sonydna.common.extensions

import android.content.pm.ApplicationInfo
import android.content.pm.PackageInfo
import android.content.pm.PackageManager
import android.content.pm.PackageManager.NameNotFoundException

import com.sonydna.common.annotation.null_analysis.NonNullByDefault
import com.sonydna.common.annotation.null_analysis.Nullable

@NonNullByDefault
final class ScPackageManager {
    
    def static final getApplicationLabel() {
        val c = ScApp.instance
        c.packageManager.getApplicationLabel(c.applicationInfo)
    }

    def static final ApplicationInfo getApplicationInfo() {
        try {
            val c = ScApp.instance
            return c.packageManager.getApplicationInfo(c.packageName, PackageManager.GET_META_DATA)

        } catch(NameNotFoundException err) {
            throw new AssertionError(err)
        }
    }
    
    @Nullable def static final ApplicationInfo getApplicationInfo(String packageName) {
        try {
            val c = ScApp.instance
            return c.packageManager.getApplicationInfo(packageName, PackageManager.GET_META_DATA)

        } catch(NameNotFoundException err) {
            return null
        }
    }
    
    def static final PackageInfo getPackageInfo() {
        try {
            val c = ScApp.instance
            return c.packageManager.getPackageInfo(c.packageName, PackageManager.GET_META_DATA)

        } catch (NameNotFoundException err) {
            throw new AssertionError(err)
        }
    }
}
