package com.sonydna.common.extensions

import com.sonydna.common.annotation.functional_programming.AsPure
import com.sonydna.common.annotation.null_analysis.NonNullByDefault
import android.graphics.Point
import android.graphics.PointF

@NonNullByDefault
final class ScPoint {
	
    //	conversions ///////////////////////////////////////
    
    @AsPure def static final Point asPoint(PointF e) { new Point(e.x as int, e.y as int) }
	
    //	xtend operator overload ///////////////////////////
    
    @AsPure def static final Point operator_plus     (Point e1, Point e2) { new Point(e1.x + e2.x, e1.y + e2.y) }
    @AsPure def static final Point operator_minus    (Point e1, Point e2) { new Point(e1.x - e2.x, e1.y - e2.y) }
    
    @AsPure def static final Point operator_multiply (Point p, int   e)   { new Point(p.x * e, p.y * e) }
    @AsPure def static final Point operator_divide   (Point p, int   e)   { new Point(p.x / e, p.y / e) }
    
    @AsPure def static final Point operator_multiply (Point p, float e)   { new Point((p.x * e) as int, (p.y * e) as int) }
    @AsPure def static final Point operator_divide   (Point p, float e)   { new Point((p.x / e) as int, (p.y / e) as int) }
    
    ///////////////////////////////////////////////////////
    
    def static final Point clone(Point e) { new Point(e.x, e.y) }
}