package com.sonydna.common.idiom

import java.nio.ByteBuffer
import java.io.OutputStream
import java.io.File
import java.io.IOException
import java.io.FileOutputStream
import android.graphics.Bitmap
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1

class LoanPattern2 {
	
    def negative(ByteBuffer buffer) {
        for (i: 0..buffer.capacity) {
            val color          = buffer.get(i)
            val negative_color = (255 - color) as byte
            buffer.put(i, negative_color)
        }
    }
    
    def void cacheNegativeBitmap_pattern1(Bitmap bitmap, File file) throws IOException {
        if (bitmap.getConfig() != Bitmap.Config.RGB_565) throw new AssertionError

        val int byteSize = bitmap.getWidth() * bitmap.getHeight() * 2;

		onDirectByteBuffer(byteSize, [ByteBuffer buffer | 
			bitmap.copyPixelsToBuffer(buffer);
			negative(buffer);
			onOutputStream(file, [OutputStream fos | 
				fos.write(buffer.array());
			]);
		]);
    }
    
    def cacheNegativeBitmap_pattern2(Bitmap bitmap, File file) throws IOException {
        if (bitmap.config != Bitmap.Config.RGB_565) throw new AssertionError

        val byteSize = bitmap.width * bitmap.height * 2
		byteSize.onDirectByteBuffer[e | bitmap.copyPixelsToBuffer(e); e.negative; file.onOutputStream[write(e.array)] ]
    }
    
    def static onDirectByteBuffer(int byteSize, Procedure1<ByteBuffer> delegate) {
        val buffer = ByteBuffer.allocateDirect(byteSize)
        try {
            delegate.apply(buffer)
        } finally {
            buffer.clear
        }
    }

    def static onOutputStream(File file, Procedure1<OutputStream> delegate) throws IOException {
        val fos = new FileOutputStream(file)
        try {
            delegate.apply(fos)
        } finally {
            fos.close
        }
    }
}