package com.sonydna.common.idiom

import android.test.AndroidTestCase

class XtendTest extends AndroidTestCase {
    
    def test01() {
    	val e = (0..9).map[it + 1].fold(0, [e1, e2 | e1 + e2])
    	assertEquals(e, 55)
    }
    
	def static test02() {
		val movies = #[
			new Movie => [ year = 1980; rating = 4.0; title = "A" ],
			new Movie => [ year = 1984; rating = 4.1; title = "B" ],
			new Movie => [ year = 1991; rating = 4.3; title = "C" ],
			new Movie => [ year = 1984; rating = 4.2; title = "D" ]
		]
		val bestHit = movies.filter[ (1980..1989).contains(year) ].sortBy[ -rating ].head.title
		assertEquals(bestHit, "D")
	}
}

class Movie {
    public int    year
    public double rating
    public String title
}
