package com.sonydna.millionmoments.core.layout

import android.test.AndroidTestCase
import com.sonydna.common.extensions.ScDimension
import com.sonydna.millionmoments.core.layout.PageLayoutList

class PageLayoutListTest extends AndroidTestCase {
	def test() {
		val e = new PageLayoutList(new ScDimension(480, 800))

		assertTrue(e.getPageLayoutFromLayoutId("NL001001").mLayoutId == "NL001001")
		assertTrue(e.getPageLayoutFromLayoutId("NL003002").mLayoutId == "NL003002")
		assertTrue(e.getPageLayoutFromLayoutId("NL005001").mLayoutId == "NL005001")
		assertTrue(e.getPageLayoutFromLayoutId("ML002001").mLayoutId == "ML002001")
		assertTrue(e.getPageLayoutFromLayoutId("ML004001").mLayoutId == "ML004001")
		assertTrue(e.getPageLayoutFromLayoutId("-1").mLayoutId == "-1")
		assertTrue(e.getPageLayoutFromLayoutId("-3").mLayoutId == "-3")

		//ページ
		assertTrue(e.getPageLayoutListFromPhotoCount(1).size == 1)
		assertTrue(e.getPageLayoutListFromPhotoCount(2).size == 4)
		assertTrue(e.getPageLayoutListFromPhotoCount(3).size == 6)
		assertTrue(e.getPageLayoutListFromPhotoCount(4).size == 6)
		assertTrue(e.getPageLayoutListFromPhotoCount(5).size == 1)

		//月表紙
		assertTrue(e.getCoverPageLayoutListFromPhotoCount(1).size == 1)
		assertTrue(e.getCoverPageLayoutListFromPhotoCount(2).size == 1)
		assertTrue(e.getCoverPageLayoutListFromPhotoCount(3).size == 1)
		assertTrue(e.getCoverPageLayoutListFromPhotoCount(4).size == 1)
		assertTrue(e.getCoverPageLayoutListFromPhotoCount(5).size == 1)

		assertTrue(e.getPageLayoutListFromPhotoCount(-1).size == 0)
		assertTrue(e.getCoverPageLayoutListFromPhotoCount(-1).size == 0)
	}
}